#ifndef __CONTROLLER__
#define __CONTROLLER__

#include <cstdint>
#include "CommonDefine.h"
#include "RangingSensor.h"
#include "TwinWheelDriver.h"
#include "Position.h"
#include "CNetMqtt.h"

class Score;

class Controller {
private:
    TwinWheelDriver *twinWheelDriver;
    Position *position;
    RangingSensor *rangingSensor;
    CNetMqtt netMqtt;
    Score *score;

    enMsgId_t enMsg;

protected:
    Controller(void);
    ~Controller(void);

public:
    static Controller* _instance;

    static Controller* getInstance(void);

    // Positionn
    void reset(void);
    void getPosition(float* distance, float* angle);

    // twinWheelDrivern
    void changeDriveMode(Mode mode, int voltage_level);

    // RangingSensorn
    float getRanging(void);

    // Coursen
    void getNextScoreTable(int nextScoreTable[4]);
    int subscrTopic(void);
    int dequeueMessage(void);

};

#endif
